public class Bookmark { 
    int    id;
    int    pos;
    String name;
    String url;


    byte[] pack() { 
        byte[] nameBytes = Converter.packString(name);
        byte[] urlBytes = url.getBytes();
        byte[] record = new byte[nameBytes.length + urlBytes.length + 5];
        Converter.packInt(record, 0, pos);
        record[4] = (byte)nameBytes.length;
        System.arraycopy(nameBytes, 0, record, 5, nameBytes.length);
        System.arraycopy(urlBytes, 0, record, nameBytes.length + 5, urlBytes.length);
        return record;
    }
    
    void unpack(byte[] record) { 
        pos = Converter.unpackInt(record, 0);
        int nameLen =  record[4] & 0xFF;
        name = Converter.unpackString(record, 5, nameLen);
        url = new String(record, 5 + nameLen, record.length-5-nameLen);
    }
    
    public int hashCode() { 
        return url.hashCode() ^ name.hashCode();
    }
    
    public boolean equals(Object o) { 
        return o instanceof Bookmark && name.equals(((Bookmark)o).name)
            && (name == Locale.LAST || url.equals(((Bookmark)o).url));
    }

    Bookmark(int id, byte[] record) { 
        this.id = id;
        unpack(record);
    }

    Bookmark(int pos, String name, String url) { 
        this.pos = pos;
        this.name = name;
        this.url = url;
    }
}
   