public class Converter {
    static void packInt(byte[] arr, int offs, int x) { 
        arr[offs] = (byte)(x >> 24);
        arr[offs+1] = (byte)(x >> 16);
        arr[offs+2] = (byte)(x >> 8);
        arr[offs+3] = (byte)x;
    }

    static int unpackInt(byte[] arr, int offs) { 
        return (arr[offs] << 24) | ((arr[offs+1] & 0xFF) << 16) | ((arr[offs+2] & 0xFF) << 8) | (arr[offs+3] & 0xFF);
    }

    static byte[] packString(String str) { 
        char[] chars = str.toCharArray();
        byte[] bytes = new byte[chars.length*2];
        for (int i = 0; i < chars.length; i++) { 
            bytes[i*2] = (byte)(chars[i] >> 8);
            bytes[i*2+1] = (byte)chars[i];
        }
        return bytes;
    }
    
    static String unpackString(byte[] arr, int offs, int len) { 
        len >>= 1;
        char[] chars = new char[len];
        for (int i = 0; i < len; i++) { 
            chars[i] = (char)((arr[offs + i*2] << 8) | (arr[offs + i*2 + 1] & 0xFF));
        }  
        return new String(chars);              
    }
}

