import javax.microedition.lcdui.*;
import java.io.*;

public class WebSearchForm extends Form implements CommandListener { 
    Menu        menu;
    TextField   query;
    ChoiceGroup scope;

    static String queryText;

    static final int MAX_QUERY_LENGTH = 128;
    static String URL = "www.google.com/search?";

    WebSearchForm(Menu menu) { 
        super(Locale.WEB_SEARCH);
        this.menu = menu;
        addCommand(MobiBrowser.SEARCH_CMD);
        addCommand(MobiBrowser.BACK_CMD);
        query = new TextField(null, queryText, MAX_QUERY_LENGTH, TextField.ANY);
        append(query);
        scope = new ChoiceGroup(Locale.SEARCH_IN, Choice.EXCLUSIVE, 
                                new String[]{Locale.INTERNET, Locale.LANGUAGE}, null);
        append(scope);
        setCommandListener(this);
        Display.getDisplay(menu.browser).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == MobiBrowser.SEARCH_CMD) { 
            queryText = query.getString().trim();
            if (queryText.length() == 0) { 
                return;
            }
            StringBuffer buf = new StringBuffer();
            buf.append(URL);
            buf.append("hl=");
            buf.append(Locale.LANGUAGE_CODE);
            buf.append("&q=");
            byte[] bytes;
            try { 
                bytes = queryText.getBytes("UTF-8");
            } catch (UnsupportedEncodingException x) {
                 bytes = queryText.getBytes();
            }
            for (int i = 0; i < bytes.length; i++) { 
                byte b = bytes[i];
                if (b < 0) { 
                    buf.append('%');
                    buf.append(Integer.toHexString(b & 0xFF));
                } else if (b == ' ') { 
                    buf.append("%20");
                } else { 
                    buf.append((char)b);
                }
            }
            buf.append("&lr=");
            if (scope.getSelectedIndex() != 0) { 
                buf.append("lang_");
                buf.append(Locale.LANGUAGE_CODE);
            }
            new ConnectForm(buf.toString(), 0, menu.browser);
            return;
        }
        Display.getDisplay(menu.browser).setCurrent(menu);
    }
}


